.section	".rodata"
.align	8
.section	".text"
f_14:
	set	123, %i2
	retl
	nop
g_16:
	set	456, %i2
	retl
	nop
h_18:
	set	789, %i2
	retl
	nop
.global	min_caml_start
min_caml_start:
	save	%sp, -112, %sp
	st	%o7, [%i0 + 4]
	call	f_14
	add	%i0, 8, %i0	! delay slot
	sub	%i0, 8, %i0
	ld	[%i0 + 4], %o7
	st	%i2, [%i0 + 0]
	st	%o7, [%i0 + 4]
	call	g_16
	add	%i0, 8, %i0	! delay slot
	sub	%i0, 8, %i0
	ld	[%i0 + 4], %o7
	st	%i2, [%i0 + 4]
	st	%o7, [%i0 + 12]
	call	h_18
	add	%i0, 16, %i0	! delay slot
	sub	%i0, 16, %i0
	ld	[%i0 + 12], %o7
	cmp	%i2, 0
	bne	be_else_42
	nop
	ld	[%i0 + 0], %i2
	add	%i2, 1, %i2
	b	be_cont_43
	nop
be_else_42:
	ld	[%i0 + 4], %i2
	add	%i2, 2, %i2
be_cont_43:
	ld	[%i0 + 0], %i3
	add	%i2, %i3, %i2
	ld	[%i0 + 4], %i3
	add	%i2, %i3, %i2
	st	%o7, [%i0 + 12]
	call	min_caml_print_int
	add	%i0, 16, %i0	! delay slot
	sub	%i0, 16, %i0
	ld	[%i0 + 12], %o7
	ret
	restore
